/*
 * com/ngon/tap/Clip2.java
 * Victor Liu > mailto:victor@n-gon.com
 *
 * Copyright (C) 2004 Victor Liu
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.ngon.tap;

import com.ngon.app.App;
import com.ngon.gfx.PixelSurface;

/**
 * class Clip2
 */
class Clip2 extends Clip {
    
    Clip2(String clipsPath, String clipName, App app) {
        super(clipsPath, clipName, app);
        this.nStreams = 2;
    }
    
    public String[] getMPEGFilenames(String clipsPath, String clipName, 
                                     int frameNr) {
        String[] mpegFilenames = new String[2];
        String s = clipsPath + clipName + "/" + clipName;
        mpegFilenames[0] = new String(s + ".+0.mpg");
        mpegFilenames[1] = new String(s + ".+1.mpg");
        return mpegFilenames;
    }
    
    protected boolean advanceDecs(int nTries) {
        for (int i = 0; i < 2; i++) {
            if (frameNr == 0 && i == 1) {
                break;
            }
            frames[i] = null;
            int cnt = 0;
            do {
                if ((frames[i] = decs[i].nextFrame()) != null) {
                    break;
                }
                if (++cnt >= nTries) {
                    return false;
                }
                try {
                    Thread.sleep(50);
                } catch (InterruptedException e) {}
            } while (true);
        }
        return true;
    }
    
    protected void incrementFrameNr() {
        if ((frames[0] != null) && ((frames[1] != null) || (frameNr == 0))) {
            active = (frameNr % 2 == 1) ? 0 : 1;
            super.incrementFrameNr();
        }
    }
}

