/*
 * com/ngon/tap/ClipSegFactory.java
 * Victor Liu > mailto:victor@n-gon.com
 *
 * Copyright (C) 2004 Victor Liu
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.ngon.tap;

import com.ngon.app.App;
import java.util.Hashtable;

/**
 * class ClipSegFactory
 */
class ClipSegFactory {
    
    protected String clipsPath;
    protected Hashtable clipInfo;
    protected App app;
    
    ClipSegFactory(String clipsPath, Hashtable clipInfo, App app) {
        this.clipsPath = clipsPath;
        this.clipInfo = clipInfo;
        this.app = app;
    }
    
    ClipSeg create(int clipID, int frameNr) {
        ClipInfo ci = (ClipInfo) clipInfo.get(new Integer(clipID));
        if (ci == null) {
            System.err.println(
                "ClipSegFactory.create() : Couldn't create clip for clip " +
                clipID + ", frame " + frameNr);
            return null;
        }
        // Also make sure we're not too close to the end of the whole clip.
        if (frameNr >= ci.clipLen-3) {
            return null;
        }
        ClipSeg c = new ClipSeg(clipsPath, ci.clipName, app);
        c.setClipID(clipID);
        c.setClipLength(ci.clipLen);
        c.setFrameNr(frameNr);
        c.setNrRetries(1);
        if (Debug.DEBUG || Debug.DEBUG_APPLET) {
            System.err.println("Creating clip " + clipID + "." + frameNr);
        }
        return c;
    }
}

