/*
 * com/ngon/util/Timer.java
 * Victor Liu > mailto:victor@n-gon.com
 *
 * Copyright (C) 2002 Victor Liu See-le
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.ngon.util;

/*
 * class Timer
 * 
 * General purpose timer
 */
public class Timer extends Thread {

    protected TimerListener notifyTarget;
    protected int delay;
    protected int loops;
    protected int loopCount;

    /* Set loops = -1 to go on forever */
    public Timer(TimerListener notifyTarget, int delay, int loops) {
        this.notifyTarget = notifyTarget;
        this.delay = delay;
        this.loops = loops;
        loopCount = 0;
        setDaemon(true);
    }

    public void run() {
        while (true) {
            try {
                Thread.sleep(delay);
            } catch (InterruptedException e) {
                return;
            }
            notifyTarget.timerTriggered();
            if (loopCount++ == loops) {
                return;
            }
        }
    }
}
